//----- Start of code section for horizontal fields of DISPLAYx -------
// s4:PH1:MAGV2  s5:Max_height-1 s6:Max_height:DY2 s7:DH2 v0:result_acc
//---------------------------------------------------------------------
// .------.-------.------------.---------------------------------------.-------.
// | Name | Pos.  | Format     | Contents                              | Mask  |
// |      |       |            |                                       |       |
// |------+-------+------------+---------------------------------------+-------+
// | MAGV | 28:27 | int 0: 2:0 | magnification in vertical direction   | 0x3   |
// '------^-------^------------^---------------------------------------^-------^
	"dsrl $t2,$t9,27\n\t"       //t2=request value aligned for MAGV
	"andi $t2,$t2,0x03\n\t"     //t2=MAGV1 masked
	"addi $t2,$t2,1\n\t"        //t2=YScale1 = MAGV1+1
// .------.-------.------------.---------------------------------------.-------.
// | Name | Pos.  | Format     | Contents                              | Mask  |
// |      |       |            |                                       |       |
// |------+-------+------------+---------------------------------------+-------+
// | DH   | 54:44 | int 0:11:0 | display area height - 1 (pixel units) | 0x7FF |
// '------^-------^------------^---------------------------------------^-------^
	"dsrl32	$t3,$t9,12\n\t"     //t3=request value aligned for DH
	"andi	$t3,$t3,0x07FF\n\t"   //t3=DH1 masked
	"addi	$t3,$t3,1\n\t"        //t3=(DH1+1) = PH1
	"divu $t3,$t2\n\t"          //LO=PH1 = (DH1+1)/YScale1
	"dsrl32 $t2,$t7,12\n\t"     //t2=forcing template aligned for DH
	"andi $s5,$t2,0x07FF\n\t"   //s5=Max_Height-1 masked
	"mflo	$s4\n\t"              //s4=PH1
	"addi $s6,$s5,1\n\t"        //s6=Max_Height
	"nop\n\t"
	"divu	$s6,$s4\n\t"          //LO=YScale2 = Max_Height/PH1
	"nop\n\t"
	"nop\n\t"
	"mflo $t2\n\t"              //t2=YScale2
	"bne $t2,$zero,21f\n\t"     //if(!YScale2) //YScale2 invalid
	"nop\n\t"                   //{
	"or $s7,$zero,$s5\n\t"      //	s7=DH2 = Max_Height-1
	"sub $t2,$s6,$s4\n\t"       //	t2=(Max_Height-PH1)
	"li $s4,0\n\t"              //	s4=MAGV2 = 0
	"beq $zero,$zero,23f\n\t"		//}
	"nop\n\t"                   //else //YScale2 non-zero
"21:\n\t"                     //{
	"addi $t3,$t2,-4\n\t"       //	t3=YScale2-4
	"bgtzl $t3,22f\n\t"         //	if(t3>0)
	"or $t2,$zero,4\n\t"        //		t2=YScale2=4;
"22:\n\t"
	"mult $s4,$t2\n\t"          //	LO=(PH1*YScale2)
	"nop\n\t"
	"nop\n\t"
	"mflo $t3\n\t"              //	t3=(PH1*YScale2)
	"addi $s7,$t3,-1\n\t"       //	s7=DH2 = (PH1*YScale2)-1

	"addi $s4,$t2,-1\n\t"       //	s4=MAGV2 = YScale2-1
	"sub $t2,$s5,$s7\n\t"       //	t2=(Max_Height-1-DH2)
"23:\n\t"                     //}
	"dsra $t2,$t2,1\n\t"        //t2=t2/2 = half_excess_height (can be negative)
// .------.-------.------------.---------------------------------------.-------.
// | Name | Pos.  | Format     | Contents                              | Mask  |
// |      |       |            |                                       |       |
// |------+-------+------------+---------------------------------------+-------+
// | DY   | 22:12 | int 0:11:0 | y pos in display area (raster units)  | 0x7FF |
// '------^-------^------------^---------------------------------------^-------^
	"dsrl	$t3,$t7,12\n\t"       //t3=forcing template aligned for DY
	"andi $t3,$t3,0x07FF\n\t"   //t3=Min_DY masked
	"add $s6,$t2,$t3\n\t"       //s6=DY2
	"bltzl $s6,24f\n\t"         //if(DY2<0)
	"and $s6,$s6,$zero\n\t"     //	DY2=0;
"24:\n\t"
	"sub $t2,$t3,$s6\n\t"       //t2=Min_DY-DY2 
	"bgtzl $t2,25f\n\t"         //if(Min_DY > DY2)
	"add $s7,$s7,$t2\n\t"       //	s7 += Min_DY-DY2  //DH2 adjusted
"25:\n\t"
	"andi $s7,$s7,0x07FF\n\t"   //s7=DH2 masked
	"andi $s4,$s4,0x0003\n\t"   //s4=MAGV2 masked
	"andi $s6,$s6,0x07FF\n\t"   //s6=DY2 masked
	"dsll32 $t2,$s7,12\n\t"     //t2=DH2 aligned for DISPLAYx
	"or $v0,$v0,$t2\n\t"        //Accumulate DH field to DISPLAYx value in v0
	"dsll $t2,$s4,27\n\t"       //t2=MAGV2 aligned for DISPLAYx
	"or $v0,$v0,$t2\n\t"        //Accumulate MAGV field to DISPLAYx value in v0
	"dsll $t2,$s6,12\n\t"       //t2=DY2 aligned for DISPLAYx
	"or $v0,$v0,$t2\n\t"        //Accumulate DY field to DISPLAYx value in v0
//----- End of code section for horizontal fields of DISPLAYx -----
